import org.apache.commons.io.FileUtils

import static org.apache.commons.io.FilenameUtils.concat

def params = [:]

params.moduleName      = ask("Module name [niagara]: ", "niagara", "moduleName")
params.moduleVersion   = ask("Module Version [4.0.0]: ", "4.0.0", "moduleVersion")
params.moduleGroup     = ask("Vendor [Neopsis]: ", "Neopsis", "moduleGroup")
params.preferredSymbol = ask("Preferred symbol [neo]: ", "neo", "preferredSymbol")
params.pkg             = ask("Java package [com.example]: ", "com.example", "pkg")


processTemplates 'vendor.gradle', params
processTemplates 'settings.gradle', params
processTemplates "rt/rt.gradle",  params
processTemplates "ux/ux.gradle",  params
processTemplates "wb/wb.gradle",  params
processTemplates "rt/BDemo.java", params
processTemplates "rt/Demo.java",  params
processTemplates "rt/module-include.xml",  params


File rtDir = new File(projectDir, 'rt')
File uxDir = new File(projectDir, 'ux')
File wbDir = new File(projectDir, 'wb')
File rtBuild = new File(projectDir, 'rt/rt.gradle')
File uxBuild = new File(projectDir, 'ux/ux.gradle')
File wbBuild = new File(projectDir, 'wb/wb.gradle')

rtBuild.renameTo(projectDir.name + "/rt/" + params.moduleName + "-rt.gradle")
uxBuild.renameTo(projectDir.name + "/ux/" + params.moduleName + "-ux.gradle")
wbBuild.renameTo(projectDir.name + "/wb/" + params.moduleName + "-wb.gradle")

def file1 = "Demo.java"
def file2 = "BDemo.java"
def pkgPath = params.pkg.replace('.' as char, '/' as char)


def destFile1 = new File(projectDir, concat(concat("rt/src/main/java", pkgPath), file1))
def destFile2 = new File(projectDir, concat(concat("rt/src/main/java", pkgPath), file2))

destFile1.parentFile.mkdirs()

FileUtils.moveFile(new File(projectDir, "rt/Demo.java"), destFile1)
FileUtils.moveFile(new File(projectDir, "rt/BDemo.java"), destFile2)

rtDir.renameTo(projectDir.name + "/" + params.moduleName + "-rt");
uxDir.renameTo(projectDir.name + "/" + params.moduleName + "-ux");
wbDir.renameTo(projectDir.name + "/" + params.moduleName + "-wb");





